local n=require("nixio.fs")
local i=require("luci.dispatcher")
local s=require("luci.cbi.datatypes")
local r=require("luci.http")
local e=require("luci.util")
local d=require("luci.model.uci")
local h=require("luci.sys")
local e=require("luci.controller.radicale")
if arg[1]then
local a=arg[1]
local t=""
local o=SimpleForm("_text")
o.title=e.app_title_back()
o.description=e.app_description()
o.redirect=i.build_url("admin","services","radicale").."#cbi-radicale-"..a
if a=="logger"then
o.reset=false
o.submit=translate("Reload")
local e=d.cursor()
t=e:get("radicale","logger","file_path")or"/var/log/radicale"
e:unload("radicale")
t=t.."/radicale"
elseif a=="auth"then
o.submit=translate("Save")
t="/etc/radicale/users"
elseif a=="rights"then
o.submit=translate("Save")
t="/etc/radicale/rights"
else
error("Invalid argument given as section")
end
if a~="logger"and not n.access(t)then
n.writefile(t,"")
end
local e=o:section(SimpleSection)
if a=="logger"then
e.title=translate("Log-file Viewer")
e.description=translate("Please press [Reload] button below to reread the file.")
elseif a=="auth"then
e.title=translate("Authentication")
e.description=translate("Place here the 'user:password' pairs for your users which should have access to Radicale.")
..[[<br /><strong>]]
..translate("Keep in mind to use the correct hashing algorithm !")
..[[</strong>]]
else
e.title=translate("Rights")
e.description=translate("Authentication login is matched against the 'user' key, "
.."and collection's path is matched against the 'collection' key.").." "
..translate("You can use Python's ConfigParser interpolation values %(login)s and %(path)s.").." "
..translate("You can also get groups from the user regex in the collection with {0}, {1}, etc.")
..[[<br />]]
..translate("For example, for the 'user' key, '.+' means 'authenticated user'".." "
.."and '.*' means 'anybody' (including anonymous users).")
..[[<br />]]
..translate("Section names are only used for naming the rule.")
..[[<br />]]
..translate("Leading or ending slashes are trimmed from collection's path.")
end
local e=e:option(TextValue,"_textvalue")
e.rmempty=true
if a=="logger"then
e.readonly=true
e.rows=30
function e.write()
r.redirect(i.build_url("admin","services","radicale","edit",a))
end
else
e.rows=15
function e.write(a,a,e)
if not e then e=""end
n.writefile(t,e:gsub("\r\n","\n"))
return true
end
end
function e.cfgvalue()
return n.readfile(t)or
string.format(translate("File '%s' not found !"),t)
end
return o
end
if not e.service_ok()then
local t=SimpleForm("_no_config")
t.title=e.app_title_main()
t.description=e.app_description()
t.submit=false
t.reset=false
local a=t:section(SimpleSection)
local a=a:option(DummyValue,"_update_needed")
a.rawhtml=true
if e.service_installed()=="0"then
a.value=[[<h3><strong><br /><font color="red">&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("Software package '"..e.service_name().."' is not installed.")
..[[</font><br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("required")..[[: ]]..e.service_name()..[[ ]]..e.service_required()
..[[<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;]]
..[[<a href="]]..i.build_url("admin","system","packages")..[[">]]
..translate("Please install current version !")
..[[</a><br />&nbsp;</strong></h3>]]
else
a.value=[[<h3><strong><br /><font color="red">&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("Software package '"..e.service_name().."' is outdated.")
..[[</font><br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("installed")..[[: ]]..e.service_name()..[[ ]]..e.service_installed()
..[[<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]]
..translate("required")..[[: ]]..e.service_name()..[[ ]]..e.service_required()
..[[<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;]]
..[[<a href="]]..i.build_url("admin","system","packages")..[[">]]
..translate("Please update to current version !")
..[[</a><br />&nbsp;</strong></h3>]]
end
return t
end
if not n.access("/etc/config/radicale")then
n.writefile("/etc/config/radicale","")
end
local t=Map("radicale")
t.title=e.app_title_main()
t.description=e.app_description()
function t.commit_handler(e)
if e.changed then
os.execute("/etc/init.d/radicale reload &")
end
end
local o=t:section(NamedSection,"_system")
o.title=translate("System")
o.description=nil
function o.cfgvalue(e,e)
return"_dummysection"
end
local a=o:option(DummyValue,"_startstop")
a.template="radicale/btn_startstop"
a.inputstyle=nil
a.rmempty=true
a.title=translate("Start / Stop")
a.description=translate("Start/Stop Radicale server")
function a.cfgvalue(t,t)
local e=e.get_pid(true)
if e>0 then
a.inputtitle="PID: "..e
a.inputstyle="reset"
a.disabled=false
else
a.inputtitle=translate("Start")
a.inputstyle="apply"
a.disabled=false
end
return true
end
local a=o:option(Flag,"_enabled")
a.title=translate("Auto-start")
a.description=translate("Enable/Disable auto-start of Radicale on system start-up and interface events")
a.orientation="horizontal"
a.rmempty=false
function a.cfgvalue(e,e)
return(h.init.enabled("radicale"))and"1"or"0"
end
function a.write(t,t,e)
if e=="1"then
return h.init.enable("radicale")
else
return h.init.disable("radicale")
end
end
local a=t:section(NamedSection,"server","setting")
a.title=translate("Server")
a.description=nil
function a.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local o=a:option(DynamicList,"hosts")
o.title=translate("Address:Port")
o.description=translate("'Hostname:Port' or 'IPv4:Port' or '[IPv6]:Port' Radicale should listen on")
..[[<br /><strong>]]
..translate("Port numbers below 1024 (Privileged ports) are not supported")
..[[</strong>]]
o.placeholder="0.0.0.0:5232"
o.rmempty=true
local o=a:option(Value,"realm")
o.title=translate("Logon message")
o.description=translate("Message displayed in the client when a password is needed.")
o.default="Radicale - Password Required"
o.rmempty=false
function o.parse(e,t)
AbstractValue.parse(e,t,"true")
end
function o.validate(t,e)
if e then
return e
else
return t.default
end
end
function o.write(e,t,a)
if a~=e.default then
return e.map:set(t,e.option,a)
else
return e.map:del(t,e.option)
end
end
local o=a:option(Flag,"ssl")
o.title=translate("Enable HTTPS")
o.description=nil
o.rmempty=false
function o.parse(a,t)
e.flag_parse(a,t)
end
function o.write(e,t,a)
if a=="0"then
e.map:del(t,"protocol")
e.map:del(t,"certificate")
e.map:del(t,"key")
e.map:del(t,"ciphers")
return e.map:del(t,e.option)
else
return e.map:set(t,e.option,a)
end
end
local e=a:option(ListValue,"protocol")
e.title=translate("SSL Protocol")
e.description=translate("'AUTO' selects the highest protocol version that client and server support.")
e.widget="select"
e.default="PROTOCOL_SSLv23"
e:depends("ssl","1")
e:value("PROTOCOL_SSLv23",translate("AUTO"))
e:value("PROTOCOL_SSLv2","SSL v2")
e:value("PROTOCOL_SSLv3","SSL v3")
e:value("PROTOCOL_TLSv1","TLS v1")
e:value("PROTOCOL_TLSv1_1","TLS v1.1")
e:value("PROTOCOL_TLSv1_2","TLS v1.2")
local e=a:option(Value,"certificate")
e.title=translate("Certificate file")
e.description=translate("Full path and file name of certificate")
e.placeholder="/etc/radicale/ssl/server.crt"
e.rmempty=false
e:depends("ssl","1")
function e.parse(a,e)
local t=o:formvalue(e)or"0"
local t=(t=="0")
AbstractValue.parse(a,e,t)
end
function e.validate(t,e)
local a=o:formvalue(a.section)or"0"
if a=="0"then
return""
end
if e then
if s.file(e)then
return e
else
return nil,t.title.." - "..translate("File not found !")
end
else
return nil,t.title.." - "..translate("Path/File required !")
end
end
function e.write(e,a,t)
if not t or#t==0 then
return e.map:del(a,e.option)
else
return e.map:set(a,e.option,t)
end
end
local e=a:option(Value,"key")
e.title=translate("Private key file")
e.description=translate("Full path and file name of private key")
e.placeholder="/etc/radicale/ssl/server.key"
e.rmempty=false
e:depends("ssl","1")
function e.parse(t,e)
local a=o:formvalue(e)or"0"
local a=(a=="0")
AbstractValue.parse(t,e,a)
end
function e.validate(t,e)
local a=o:formvalue(a.section)or"0"
if a=="0"then
return""
end
if e then
if s.file(e)then
return e
else
return nil,t.title.." - "..translate("File not found !")
end
else
return nil,t.title.." - "..translate("Path/File required !")
end
end
function e.write(e,a,t)
if not t or#t==0 then
return e.map:del(a,e.option)
else
return e.map:set(a,e.option,t)
end
end
local a=t:section(NamedSection,"auth","setting")
a.title=translate("Authentication")
a.description=translate("Authentication method to allow access to Radicale server.")
function a.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local e=a:option(ListValue,"type")
e.title=translate("Authentication method")
e.description=nil
e.widget="select"
e.default="None"
e:value("None",translate("None"))
e:value("htpasswd",translate("htpasswd file"))
function e.write(e,t,a)
if a~="htpasswd"then
e.map:del(t,"htpasswd_encryption")
elseif a~="IMAP"then
e.map:del(t,"imap_hostname")
e.map:del(t,"imap_port")
e.map:del(t,"imap_ssl")
end
if a~=e.default then
return e.map:set(t,e.option,a)
else
return e.map:del(t,e.option)
end
end
local e=a:option(ListValue,"htpasswd_encryption")
e.title=translate("Encryption method")
e.description=nil
e.widget="select"
e.default="crypt"
e:depends("type","htpasswd")
e:value("crypt",translate("crypt"))
e:value("plain",translate("plain"))
e:value("sha1",translate("SHA-1"))
e:value("ssha",translate("salted SHA-1"))
local e=a:option(DummyValue,"_htf")
e.title=translate("htpasswd file")
e.description=[[<strong>]]
..translate("Read only!")
..[[</strong> ]]
..translate("Radicale uses '/etc/radicale/users' as htpasswd file.")
..[[<br /><a href="]]
..i.build_url("admin","services","radicale","edit")..[[/auth]]
..[[">]]
..translate("To edit the file follow this link!")
..[[</a>]]
e.keylist={}
e.vallist={}
e.template="radicale/ro_value"
e.readonly=true
e:depends("type","htpasswd")
function e.cfgvalue()
return"/etc/radicale/users"
end
local a=t:section(NamedSection,"rights","setting")
a.title=translate("Rights")
a.description=translate("Control the access to data collections.")
function a.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local e=a:option(ListValue,"type")
e.title=translate("Rights backend")
e.description=nil
e.widget="select"
e.default="None"
e:value("None",translate("Full access for everybody (including anonymous)"))
e:value("authenticated",translate("Full access for authenticated Users"))
e:value("owner_only",translate("Full access for Owner only"))
e:value("owner_write",translate("Owner allow write, authenticated users allow read"))
e:value("from_file",translate("Rights are based on a regexp-based file"))
function e.write(e,a,t)
if t~="custom"then
e.map:del(a,"custom_handler")
end
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local e=a:option(DummyValue,"_rtf")
e.title=translate("RegExp file")
e.description=[[<strong>]]
..translate("Read only!")
..[[</strong> ]]
..translate("Radicale uses '/etc/radicale/rights' as regexp-based file.")
..[[<br /><a href="]]
..i.build_url("admin","services","radicale","edit")..[[/rights]]
..[[">]]
..translate("To edit the file follow this link!")
..[[</a>]]
e.keylist={}
e.vallist={}
e.template="radicale/ro_value"
e.readonly=true
e:depends("type","from_file")
function e.cfgvalue()
return"/etc/radicale/rights"
end
local o=t:section(NamedSection,"storage","setting")
o.title=translate("Storage")
o.description=nil
function o.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local e=o:option(ListValue,"type")
e.title=translate("Storage backend")
e.description=translate("WARNING: Only 'File-system' is documented and tested by Radicale development")
e.widget="select"
e.default="filesystem"
e:value("filesystem",translate("File-system"))
function e.write(e,a,t)
if t~="filesystem"then
e.map:del(a,"filesystem_folder")
end
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local a=o:option(Value,"filesystem_folder")
a.title=translate("Directory")
a.description=nil
a.default="/srv/radicale"
a.rmempty=false
a:depends("type","filesystem")
function a.parse(a,t)
local e=e:formvalue(o.section)or""
local e=(e~="filesystem")
AbstractValue.parse(a,t,e)
end
function a.validate(a,t)
local e=e:formvalue(o.section)or""
if e~="filesystem"then
return""
end
if t then
if s.directory(t)then
return t
else
return nil,a.title.." - "..translate("Directory not exists/found !")
end
else
return nil,a.title.." - "..translate("Directory required !")
end
end
local a=t:section(NamedSection,"logger","logging")
a.title=translate("Logging")
a.description=nil
function a.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local e=a:option(ListValue,"console_level")
e.title=translate("Console Log level")
e.description=nil
e.widget="select"
e.default="ERROR"
e:value("DEBUG",translate("Debug"))
e:value("INFO",translate("Info"))
e:value("WARNING",translate("Warning"))
e:value("ERROR",translate("Error"))
e:value("CRITICAL",translate("Critical"))
function e.write(e,a,t)
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local e=a:option(ListValue,"syslog_level")
e.title=translate("Syslog Log level")
e.description=nil
e.widget="select"
e.default="WARNING"
e:value("DEBUG",translate("Debug"))
e:value("INFO",translate("Info"))
e:value("WARNING",translate("Warning"))
e:value("ERROR",translate("Error"))
e:value("CRITICAL",translate("Critical"))
function e.write(e,a,t)
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local e=a:option(ListValue,"file_level")
e.title=translate("File Log level")
e.description=nil
e.widget="select"
e.default="INFO"
e:value("DEBUG",translate("Debug"))
e:value("INFO",translate("Info"))
e:value("WARNING",translate("Warning"))
e:value("ERROR",translate("Error"))
e:value("CRITICAL",translate("Critical"))
function e.write(e,a,t)
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local e=a:option(Value,"file_path")
e.title=translate("Log-file directory")
e.description=translate("Directory where the rotating log-files are stored")
..[[<br /><a href="]]
..i.build_url("admin","services","radicale","edit")..[[/logger]]
..[[">]]
..translate("To view latest log file follow this link!")
..[[</a>]]
e.default="/var/log/radicale"
function e.write(e,a,t)
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local e=a:option(Value,"file_maxbytes")
e.title=translate("Log-file size")
e.description=translate("Maximum size of each rotation log-file.")
..[[<br /><strong>]]
..translate("Setting this parameter to '0' will disable rotation of log-file.")
..[[</strong>]]
e.default="8196"
e.rmempty=false
function e.validate(t,e)
if e then
if s.uinteger(e)then
return e
else
return nil,t.title.." - "..translate("Value is not an Integer >= 0 !")
end
else
return nil,t.title.." - "..translate("Value required ! Integer >= 0 !")
end
end
function e.write(e,t,a)
if a~=e.default then
return e.map:set(t,e.option,a)
else
return e.map:del(t,e.option)
end
end
local e=a:option(Value,"file_backupcount")
e.title=translate("Log-backup Count")
e.description=translate("Number of backup files of log to create.")
..[[<br /><strong>]]
..translate("Setting this parameter to '0' will disable rotation of log-file.")
..[[</strong>]]
e.default="1"
e.rmempty=false
function e.validate(t,e)
if e then
if s.uinteger(e)then
return e
else
return nil,t.title.." - "..translate("Value is not an Integer >= 0 !")
end
else
return nil,t.title.." - "..translate("Value required ! Integer >= 0 !")
end
end
function e.write(e,a,t)
if t~=e.default then
return e.map:set(a,e.option,t)
else
return e.map:del(a,e.option)
end
end
local e=t:section(NamedSection,"encoding","setting")
e.title=translate("Encoding")
e.description=translate("Change here the encoding Radicale will use instead of 'UTF-8' "
.."for responses to the client and/or to store data inside collections.")
function e.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local a=e:option(Value,"request")
a.title=translate("Response Encoding")
a.description=translate("Encoding for responding requests.")
a.default="utf-8"
a.optional=true
local e=e:option(Value,"stock")
e.title=translate("Storage Encoding")
e.description=translate("Encoding for storing local collections.")
e.default="utf-8"
e.optional=true
local e=t:section(NamedSection,"headers","setting")
e.title=translate("Additional HTTP headers")
e.description=translate("Cross-origin resource sharing (CORS) is a mechanism that allows restricted resources (e.g. fonts, JavaScript, etc.) "
.."on a web page to be requested from another domain outside the domain from which the resource originated.")
function e.cfgvalue(e,t)
if not e.map:get(t)then
e.map:set(t,nil,e.sectiontype)
end
return e.map:get(t)
end
local a=e:option(DynamicList,"Access_Control_Allow_Origin")
a.title=translate("Access-Control-Allow-Origin")
a.description=nil
a.default="*"
a.optional=true
local a=e:option(DynamicList,"Access_Control_Allow_Methods")
a.title=translate("Access-Control-Allow-Methods")
a.description=nil
a.optional=true
local a=e:option(DynamicList,"Access_Control_Allow_Headers")
a.title=translate("Access-Control-Allow-Headers")
a.description=nil
a.optional=true
local e=e:option(DynamicList,"Access_Control_Expose_Headers")
e.title=translate("Access-Control-Expose-Headers")
e.description=nil
e.optional=true
return t
